<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 4.6 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="./">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-RC1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-RC1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 4.6: Introduction to SVG visualization</h1>
                    <p>
                        Until now, if you validated your CIF model by simulating it, you used the simulator's state visualizer.
                        This is a useful tool to quickly check whether the model is correct.
                        However, for larger and more complex systems, it can be challenging to keep the overview of the state of the system.
                    </p>
                    <p>
                        To ease validation, the CIF simulator also supports <em>SVG</em> visualization.
                        You have already encountered SVG visualization in the water lock case, when you simulated the water lock in the first module.
                        SVG stands for <em>Scalable Vector Graphics</em>.
                        It is an international standard for images based on vector graphics.
                        In vector graphics, a description of a drawing is given by describing the shapes and other elements that make up the image, as well as their attributes.
                        This contrasts it to raster images, where the image is made up of pixels.
                        In order to display vector images on a computer screen, the description of the image is still rendered to pixels, converting the vector image to a raster image.
                        A benefit of vector images is that they can be rendered at any resolution, and still be sharp.
                        But, the main benefit for their use in simulation, is that we can change the attributes of the shapes and other elements, to change the image and make it reflect the current state of the system.
                    </p>
                    <p>
                        For instance, we can make an image of a traffic light, and adapt the background color of the circles of the various light during simulation, to become red and green based on the system of the system.
                        Recall for instance the entering and leaving traffic lights that regulate water traffic of a water lock:
                    </p>
                    <img src="../module1/images/lock-traffic-lights-water.png">

                    <h2>SVG visualization based on the state of a CIF model</h2>
                    <p>
                        SVG drawings thus consist of multiple elements which together form the drawing.
                        Each element in the drawing can be given a unique identifier (and <em>id</em>).
                        In your CIF model, you can then map the state of the CIF model to various attributes of the elements, such as colors, dimensions, positions, texts of labels, and so on.
                    </p>
                    <p>
                        As a very simple first example, consider a lamp that can be on or off:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton lamp:
                                event turn_on, turn_off;

                                location On:
                                    initial;
                                    marked;
                                    edge turn_off goto Off;

                                location Off:
                                    edge turn_on goto On;
                            end
                        </code>
                    </pre>
                    <p>
                        The <code>lamp</code> automaton is either in the <code>On</code> location or the <code>Off</code> location.
                        We can visualize the lamp as follows, with a vector image consisting of just a circle:
                    </p>
                    <img src="images/lamp-circle.png">
                    <p>
                        The circle is given id <code>lamp</code>, and the SVG image is saved to an SVG file named <code>lamp.svg</code>.
                        We can then connect the SVG file to the CIF model using an SVG file declaration, and establish mappings between the CIF model and elements in the SVG image by using <em>SVG output mappings</em>:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            svgfile "lamp.svg";

                            automaton lamp:
                                event turn_on, turn_off;

                                location On:
                                    initial;
                                    marked;
                                    edge turn_off goto Off;

                                location Off:
                                    edge turn_on goto On;

                                svgout id "lamp" attr "fill" value if Off: "silver" else "yellow" end;
                            end
                        </code>
                    </pre>
                    <p>
                        The CIF model now has an <code>svgfile</code> declaration at the top, indicating that the <code>lamp.svg</code> file is to be connected to this CIF model.
                        In this case, the SVG file is in the same folder as the CIF model, and therefore just the SVG file name is indicated.
                        If the SVG file would be in a sub-folder named <code>images</code>, you'd use <code>svgfile "images/lamp.svg";</code>.
                    </p>
                    <p>
                        The CIF model now also has an SVG output mapping, indicated by <code>svgout</code>.
                        It specifies that the element named <code>lamp</code> in the SVG image has an attribute named <code>fill</code>, and that the value of this attribute is to be updated based on the state of the CIF model.
                        The <code>fill</code> attribute of a circle determines its fill color.
                        In this case, if the automaton is in the <code>Off</code> location, the fill color is <code>silver</code>, and otherwise it is <code>yellow</code>.
                        The result is that the circle is either silver or yellow, depending on the current location of the automaton:
                    </p>
                    <img src="images/lamp-svg-viz.png">
                    <p>
                        In general, an SVG output mapping that changes the value of an attribute of an SVG element, requires the id of that element, the name of one of its attributes, and an expression that determines the value of the attribute.
                        The id can be given as just its name, but we can for instance also compute the id:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            svgfile "lamp2.svg";

                            automaton def Lamp(alg int nr):
                                event turn_on, turn_off;

                                location On:
                                    initial;
                                    marked;
                                    edge turn_off goto Off;

                                location Off:
                                    edge turn_on goto On;

                                svgout id "lamp" + &lt;string&gt;nr attr "fill" value if Off: "silver" else "yellow" end;
                            end

                            lamp1: Lamp(1);
                            lamp2: Lamp(2);
                        </code>
                    </pre>
                    <p>
                        The <code>lamp</code> automaton is now an automaton definition named <code>Lamp</code>, with a parameter <code>nr</code>.
                        It is instantiated twice, once with value <code>1</code> and once with value <code>2</code>.
                        The SVG output mapping uses the parameter to map to either the element with id <code>lamp1</code> or the one with id <code>lamp2</code>.
                        It does so, by adding to the text <code>lamp</code> the value of <code>nr</code> as text, which is obtained through a conversion of the number to the <code>string</code> data type that is used to represent text.
                    </p>
                    <p>
                        For the value, we here used an <code>if</code> expression.
                        It can produce different values depending on the state of the model.
                        In this case, based on whether the automaton is in location <code>Off</code> or not.
                        You can read more about <code>if</code> expressions, as well as about the related concept of <code>switch</code> expressions, in the CIF tutorial, specifically the <a href="../../cif/language-tutorial/values/if-and-switch.html">lesson on if and switch expressions</a>.
                    </p>
                    <p>
                        If you simulate a model that is connected to an SVG image, the CIF simulator will automatically open the SVG visualizer.
                        The SVG image is then automatically updated during the simulation, based on the state of the system, as shown above for the lamp being silver or yellow.
                    </p>
                    <p>
                        To learn more about SVG visualization, check out the <a href="../../cif/language-tutorial/svg/visualization.html">CIF documentation</a>.
                        It includes information about tools to create and edit SVG images, about SVG output mappings, about how to not only change shapes but also text, and so on.
                        It also includes several examples.
                    </p>

                    <h2>Interactive simulation using SVG images</h2>
                    <p>
                        So far, we have used the state of the model as output from the model to have it be reflected in the SVG image.
                        But, it is also possible to have them influence each other the other way around, by having the image affect the model.
                        That is, it is possible make mappings that specify that clicking on certain elements in the image affects the behavior of the model during simulation.
                    </p>
                    <p>
                        For this, CIF features <em>SVG input mappings</em>.
                        With an SVG input mapping, you can map an element of an SVG image and define which event should be enabled in the model when it is clicked.
                        Such an interactive SVG event is then disabled as long as the element in the image is not clicked, and only once it is clicked does the event become enabled.
                        The event can then be taken just once, after which it becomes disabled again until an element of the image that enables it is clicked.
                    </p>
                    <p>
                        As an example, consider the following model of the lamp above, extended with a button.
                        For as long as the button keeps being pushed, the lamp is on, but once the button is released, the lamp goes off again.
                        We can make an SVG image for it, and save it as <code>button_lamp.svg</code>:
                    </p>
                    <img src="images/button-lamp.png">
                    <p>
                        It still has the lamp, but now also a button.
                        We can make the following model for it:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            svgfile "button_lamp.svg";

                            plant button:
                                uncontrollable u_pushed, u_released;

                                location Released:
                                    initial;
                                    marked;
                                    edge u_pushed goto Pushed;

                                location Pushed:
                                    edge u_released goto Released;

                                svgout id "button" attr "width" value if Pushed: 12 else 36 end;
                            end

                            plant lamp:
                                controllable c_on, c_off;

                                location Off:
                                    initial;
                                    marked;
                                    edge c_on goto On;

                                location On:
                                    edge c_off goto Off;

                                svgout id "lamp" attr "fill" value if Off: "silver" else "yellow" end;
                            end

                            supervisor controller:
                                location:
                                    initial;
                                    marked;
                                    edge lamp.c_on when button.Pushed;
                                    edge lamp.c_off when button.Released;
                            end

                            svgin id "button" event if   button.Released: button.u_pushed
                                                    elif button.Pushed:   button.u_released
                                                    end;
                        </code>
                    </pre>
                    <p>
                        The SVG input mapping indicates that if the SVG element with id <code>button</code> is clicked, and the <code>button</code> automaton is in its <code>Released</code> location, then the <code>u_pushed</code> event is enabled.
                        If the automaton is instead in its <code>Pushed</code> location, then the <code>u_released</code> event is enabled.
                        It is however also possible to simply list a single event, instead of the whole <code>if</code>, and then this single event is enabled whenever the SVG element is clicked.
                        To learn more about SVG interaction and SVG input mappings, check out the <a href="../../cif/language-tutorial/svg/interaction.html">CIF documentation</a>.
                    </p>
                    <p>
                        To enable SVG interaction, you should configure the CIF simulator's <em>Input mode</em> option, in the <em>Input</em> category to <em>SVG input mode</em>.
                        If we simulate this example model, and regularly press the button, the result is something like this:
                    </p>
                    <img src="images/button-lamp-simulation-animated.gif">
                    <p>
                        When hovering over an interactive element, it gets highlighted with a red border.
                        When clicking it, it briefly gets a green border.
                        To learn more about the CIF simulator's SVG input mode, check out the <a href="../../cif/tools/cifsim/input/svg.html">CIF documentation</a>.
                    </p>

                    <h2>Simulation in a browser</h2>
                    <p>
                        The CIF simulator can be used to simulate a model interactively, through SVG visualization and interaction.
                        Sometimes, you want to share your model with others, such that they can also simulate it.
                        For instance, to have others review whether the controlled system operates as envisioned, and no requirements were missed.
                    </p>
                    <p>
                        Allowing others to simulate your model requires sharing all relevant files, including not only the CIF model file itself, but also its imported other CIF files and its connected SVG images.
                        Besides that, the other people then need to install the ESCET tooling, which includes the CIF simulator.
                        This may not be desired in all situations.
                        For instance, a person making a controller for a bridge may want to ask a bridge operator for feedback, but a bridge operator may not be used to work with tooling like Eclipse ESCET.
                        Furthermore, some companies disallow installing non-approved software on their systems.
                    </p>
                    <p>
                        An alternative way to simulate a CIF model, that addresses these concerns, is to simulate it in a browser.
                        To simulate a model in a browser, you first use the CIF code generator to generate a single HTML file from a model and its visualizations.
                        Then, the generated HTML file can be opened in any modern web browser, allowing you to interactively simulate your model without requiring Eclipse ESCET to be available.
                        Since everything that is needed for simulation is contained in a single file, it is also easy to share such a file with others, for instance as an email attachment.
                    </p>
                    <p>
                        Simulation in the browser is more limited than simulation using the CIF simulator.
                        Use simulation in a browser when sharing the model with less technical users.
                        In other situations, it is recommended to use the CIF simulator, as it has more options to configure the simulation.
                    </p>
                    <p>
                        To generate an HTML file from a CIF model, right click the <code>.cif</code> file in the <em>Project Explorer</em>, and choose <em>CIF implementation tools</em> and then <em>Generate code for CIF specification...</em>.
                        Since generating an HTML file is the default, it suffices to accept the default options and click <em>OK</em>.
                        Wait for the code generator to have written the <code>.html</code> file.
                        Then double click that generated <code>.html</code> file to open it in your browser.
                        In the browser, you can interact with the SVG image as you would in the CIF simulator.
                        For more information, see the <a href="../../cif/tools/codegen">CIF code generator documentation</a>.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "What are the advantages of SVG visualization over simulation with the state visualizer?",
                                answers: [
                                    "More possibilities for visualization and interaction.",
                                    "Less labor intensive to get started with.",
                                    "Creates a better understanding of the behavior of the modeled system.",
                                ],
                                correctAnswer: '1, 3'
                            },
                            {
                                type: 'single-choice',
                                question: "What is a correct structure of an SVG input mapping?",
                                answers: [
                                    "<code>svgin id {id name} event {event name};</code>",
                                    "<code>svgin id {event name} event {id name};</code>",
                                    "<code>svgout id {id name} attr {attr name} value if {expression}: {value when true} else {value when false} end;</code>",
                                    "<code>svgin id {id name} attr {attr name} value if {expression}: {value when true} else {value when false} end;</code>"
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: "What is a correct structure of an SVG output mapping?",
                                answers: [
                                    "<code>svgout id {id name} event {event name};</code>",
                                    "<code>svgin id {event name} event {id name};</code>",
                                    "<code>svgout id {id name} attr {attr name} value if {expression}: {value when true} else {value when false} end;</code>",
                                    "<code>svgin id {id name} attr {attr name} value if {expression}: {value when true} else {value when false} end;</code>"
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "How is an SVG image connected to the CIF model containing the mappings?",
                                answers: [
                                    "By right-clicking the CIF file, starting the simulation and in the option dialog typing in the path to the SVG image.",
                                    "By typing <code>svgfile</code> with the path to the SVG file in the CIF model.",
                                    "By typing <code>ciffile</code> with the path to the SVG file in the SVG image."
                                ],
                                correctAnswer: '2'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="performing-synthesis-with-cif.html">Go back to Module 4.5</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="exercises.html">Proceed to Module 4.7</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
